#include<opencv2/opencv.hpp>
#include<iostream>
#include<vector>
#include"XM1.h"

using namespace std;
using namespace cv;
int index;
bool f = 1;
Mat img;
VideoCapture cap(0);
vector<vector<int>> newPoints;  // to store all points

/////////////////////  COLOR VALUES ////////////////////////////////
						   // hmin, smin, vmin hmax, smax, vmax
//myColorsʵ߸ֵ
vector<vector<int>> myColors{
	{13,30,127,217,151,255}, //yellow
};


//ڲʾɫ
vector<Scalar> myColorValues{
	{0,255,255}, //blue 

};

//
Point getContours(Mat image) {


	vector<vector<Point>> contours;
	vector<Vec4i> hierarchy;

	findContours(image, contours, hierarchy, RETR_EXTERNAL, CHAIN_APPROX_SIMPLE);
	//drawContours(img, contours, -1, Scalar(255, 0, 255), 2);
	vector<vector<Point>> conPoly(contours.size());
	vector<Rect> boundRect(contours.size());

	Point myPoint(0, 0);

	for (int i = 0; i < contours.size(); i++)
	{
		int area = contourArea(contours[i]);
		cout << area << endl;

		string objectType;

		if (area > 1000)
		{
			float peri = arcLength(contours[i], true);
			approxPolyDP(contours[i], conPoly[i], 0.02 * peri, true);

			cout << conPoly[i].size() << endl;
			boundRect[i] = boundingRect(conPoly[i]);
			myPoint.x = boundRect[i].x + boundRect[i].width / 2;
			myPoint.y = boundRect[i].y;

			//drawContours(img, conPoly, i, Scalar(255, 0, 255), 2);
			//rectangle(img, boundRect[i].tl(), boundRect[i].br(), Scalar(0, 255, 0), 5);
		}
	}
	return myPoint;
}

//ͨɫжʲôɫ
vector<vector<int>> findColor(Mat img)
{
	Mat imgHSV;
	cvtColor(img, imgHSV, COLOR_BGR2HSV);


	Scalar lower(myColors[index][0], myColors[index][1], myColors[index][2]);
	Scalar upper(myColors[index][3], myColors[index][4], myColors[index][5]);
	Mat mask;
	inRange(imgHSV, lower, upper, mask);
	//imshow(to_string(i), mask);
	Point myPoint = getContours(mask);
	if (myPoint.x != 0) {
		newPoints.push_back({ myPoint.x,myPoint.y,index });
	}

	return newPoints;
}





XM1::XM1(QWidget* parent)
	: QMainWindow(parent)
{
	ui.setupUi(this);

	connect(ui.pushButton, &QPushButton::clicked, this,
		&XM1::onpic);
	connect(ui.pushButton_2, &QPushButton::clicked, this,
		&XM1::app_close);
	connect(ui.comboBox, &QComboBox::currentIndexChanged, this,
		&XM1::get_index);
}

XM1::~XM1()
{}

void drawOnCanvas(vector<vector<int>> newPoints, vector<Scalar> myColorValues)
{
	for (int i = 0; i < newPoints.size(); i++)
	{
		circle(img, Point(newPoints[i][0], newPoints[i][1]), 10, myColorValues[newPoints[i][2]], FILLED);
	}
}

void XM1::onpic() {
	while (f) {


		cap.read(img);
		newPoints = findColor(img);
		drawOnCanvas(newPoints, myColorValues);

		img_src = QImage(img.data, img.cols, img.rows, img.step, QImage::Format_BGR888);
		img_show = img_src.scaled(ui.label->size(), Qt::KeepAspectRatio, Qt::FastTransformation);
		img_pix = QPixmap::fromImage(img_show);
		ui.label->setPixmap(img_pix);
		waitKey(1);
	}
}

void XM1::app_close() {
	f = 0;
	this->close();

}

int XM1::get_index()
{
	index = ui.comboBox->currentIndex();
	QString i = QString::number(index);
	ui.label->setText(i);
	return index;
}